/*
Copyright (C) 2009 -  Claudio Salvadori 
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef IXML_H
#define IXML_H

#include <vector>
#include <string>
#include <stdlib.h>

#include "DAQ_struct.h"
#include "def_interface.h"
#include "CXmlParser.h"

using namespace std;

/**
 *\file IXml.h
 *\date  Created on: 29-mar-2009
 *\author  Author: Claudio Salvadori
 *\brief  Interface for xml parser and analyzer*/

/**
*\class IXml
*\brief Interface for xml parser
*/
DeclareInterface(IXml)
		
		/**\brief Initialize the parser
		*\return This method return one of the possible value from enum \see x_ret*/
		virtual x_ret init() = 0;
		
		/**\brief This method make the parsing operation and fill def and metadata (validating the parsed value)
		*\param title This is a pointer to a variable contains the title of the output vector (output)
		*\return This method return one of the possible value from enum \see x_ret*/
		virtual x_ret parseXml() = 0;
		
EndInterface
#endif
